REM ftp://ftp.remotesensing.org/pub/libtiff/tiff-4.0.8.tar.gz
REM
set P=libtiff
set V=4.0.8
set B=1

set ARCH=%1

if "%ARCH%"=="x86_64" (
	set OSGEO4W_ROOT=C:\OSGeo4W64
	set CMAKEGEN=Visual Studio 14 2015 Win64
	set VCARCH=x64
	set ZLIB=zdll.lib
) else if "%ARCH%"=="x86" (
	set OSGEO4W_ROOT=C:\OSGeo4W
	set CMAKEGEN=Visual Studio 14 2015
	set VCARCH=x86
	set ZLIB=zlib.lib
) else (
	echo "unsupported arch %ARCH%"
	goto error
)


set R=..\..\..\%ARCH%\release\%P%
mkdir %R%

call "C:\Program Files (x86)\Microsoft Visual Studio 14.0\VC\vcvarsall.bat" %VCARCH%
echo on
path C:\Program Files\CMake\bin;C:\Program Files (x86)\Microsoft Visual Studio 14.0\Common7\IDE;%PATH%

mkdir build-%ARCH%
cd build-%ARCH%

cmake -G "%CMAKEGEN%" ^
	-D CMAKE_INSTALL_PREFIX=..\install-%ARCH% ^
	-D JPEG_INCLUDE_DIR=%OSGEO4W_ROOT%\include ^
	-D JPEG_LIBRARY=%OSGEO4W_ROOT%\lib\jpeg_i.lib ^
	-D JPEG12_INCLUDE_DIR=%OSGEO4W_ROOT%\include\libjpeg12 ^
	-D JPEG12_LIBRARY=%OSGEO4W_ROOT%\lib\jpeg12_i.lib ^
	-D LIBLZMA_INCLUDE_DIR=%OSGEO4W_ROOT%\include ^
	-D LIBLZMA_LIBRARY=%OSGEO4W_ROOT%\lib\liblzma.lib ^
	-D ZLIB_INCLUDE_DIR=%OSGEO4W_ROOT%\include ^
	-D ZLIB_LIBRARY=%OSGEO4W_ROOT%\lib\%ZLIB% ^
	-D cxx=OFF ^
	..\..
if errorlevel 1 (echo cmake error & goto error)

cd ..

if exist ..\libtiff\tif_config.h ren ..\libtiff\tif_config.h tif_config.h.off
if exist ..\libtiff\tiffconf.h ren ..\libtiff\tiffconf.h tiffconf.h.off

for %%i in (ZERO_CHECK ALL_BUILD INSTALL) do (
        echo %%i: %DATE% %TIME%
        cmake --build build-%ARCH% --target %%i --config Release
        if errorlevel 1 (echo %%i error & goto error)
)

copy setup.hint %R%\setup.hint
copy ..\COPYRIGHT %R%\%P%-%V%-%B%.txt

copy install-%ARCH%\lib\tiff.lib install-%ARCH%\lib\libtiff_i.lib
copy install-%ARCH%\bin\tiff.dll install-%ARCH%\bin\libtiff.dll

tar -C install-%ARCH% -cjvf %R%\%P%-%V%-%B%.tar.bz2 bin include lib
tar -C .. -cjvf %R%\%P%-%V%-%B%-src.tar.bz2 osgeo4w/package.cmd osgeo4w/setup.hint

goto ok

:error

:ok
